// memory.js
//
// In-memory storage of data
//
// Copyright 2011, StatusNet Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

var databank = require('../databank'),
    Databank = databank.Databank,
    DatabankError = databank.DatabankError,
    AlreadyExistsError = databank.AlreadyExistsError,
    NoSuchThingError = databank.NoSuchThingError;

var MemoryDatabank = function(params) {
    this.schema = params.schema || {};
};

MemoryDatabank.prototype = new Databank();

MemoryDatabank.prototype.toKey = function(type, id) {
    return type + ":" + id;
};

MemoryDatabank.prototype.connect = function(params, onCompletion) {
    this.items = {};
    onCompletion(null);
};

MemoryDatabank.prototype.disconnect = function(onCompletion) {
    delete this.items;
    // Always succeed
    onCompletion(null);
};

MemoryDatabank.prototype.create = function(type, id, value, onCompletion) {
};

MemoryDatabank.prototype.update = function(type, id, value, onCompletion) {
};

MemoryDatabank.prototype.read = function(type, id, onCompletion) {
};

MemoryDatabank.prototype.del = function(type, id, onCompletion) {
};

MemoryDatabank.prototype.search = function(type, criteria, onResult, onCompletion) {
};

exports.MemoryDatabank = MemoryDatabank;
